diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 2bb059989..ae6bce942 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -2,14 +2,13 @@ package net.minecraft.server.net.handler;
 
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
-import it.unimi.dsi.fastutil.ints.Int2ShortArrayMap;
-import it.unimi.dsi.fastutil.ints.Int2ShortMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.enums.PlacementMode;
@@ -26,6 +25,7 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
+import net.minecraft.core.player.inventory.menu.MenuAbstract;
 import net.minecraft.core.player.inventory.menu.MenuFlag;
 import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
 import net.minecraft.core.player.inventory.slot.Slot;
@@ -62,13 +62,11 @@ public class PacketHandlerServer extends PacketHandler
     private double lastPosY;
     private double lastPosZ;
     private boolean hasMoved;
-    private final Int2ShortMap guiIdMap;
 
 
     public PacketHandlerServer(MinecraftServer minecraftserver, NetworkManager networkManager, PlayerServer player) {
         this.connectionClosed = false;
         this.hasMoved = true;
-        this.guiIdMap = new Int2ShortArrayMap();
         this.mcServer = minecraftserver;
         this.netManager = networkManager;
         networkManager.setNetHandler(this);
@@ -434,18 +432,19 @@ public class PacketHandlerServer extends PacketHandler
         if (itemstack != null && itemstack.stackSize <= 0) {
             this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()] = null;
         }
-        this.playerEntity.isChangingQuantityOnly = true;
         this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()] = ItemStack.copyItemStack(this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()]);
-        Slot slot = this.playerEntity.containerMenu.getSlotFor(this.playerEntity.inventory, this.playerEntity.inventory.getCurrentSlot());
-        this.playerEntity.containerMenu.broadcastChanges();
-        this.playerEntity.isChangingQuantityOnly = false;
+        MenuAbstract menu = this.playerEntity.containerMenu;
+        Slot slot = menu.getSlotFor(this.playerEntity.inventory, this.playerEntity.inventory.getCurrentSlot());
         if (slot == null) {
-            LOGGER.warn("Couldn't find slot for index '{}' in {}'s inventory while they were in the {} container!", this.playerEntity.inventory.getCurrentSlot(), this.playerEntity.username, this.playerEntity.containerMenu.getClass().getSimpleName());
+            LOGGER.warn("Couldn't find slot for index '{}' in {}'s inventory while they were in the {} container!", this.playerEntity.inventory.getCurrentSlot(), this.playerEntity.username, menu.getClass().getSimpleName());
             return;
         }
-        if (!ItemStack.areItemStacksEqual(this.playerEntity.inventory.getCurrentItem(), packet.itemStack)) {
-            sendPacket(new PacketContainerSetSlot(this.playerEntity.containerMenu.containerId, slot.index, this.playerEntity.inventory.getCurrentItem()));
+        ItemStack current = this.playerEntity.inventory.getCurrentItem();
+        if (!ItemStack.areItemStacksEqual(current, packet.itemStack)) {
+            menu.incrementStateId();
+            sendPacket(new PacketContainerSetSlot(menu.containerId, menu.getStateId(), slot.index, current));
         }
+        menu.setRemoteSlot(slot.index, current);
     }
 
     @Override
@@ -570,13 +569,21 @@ public class PacketHandlerServer extends PacketHandler
     }
 
     @Override
-    public void handleBoatControl(@NotNull PacketBoatControl packetBoatControl) {
-        if (!canInteract() || Double.isNaN(packetBoatControl.targetXD) || Double.isNaN(packetBoatControl.targetZD))
+    public void handleVehicleControl(@NotNull PacketVehicleControl packetVehicleControl) {
+        if (!canInteract()
+            || Double.isNaN(packetVehicleControl.targetXD)
+            || Double.isNaN(packetVehicleControl.targetYD)
+            || Double.isNaN(packetVehicleControl.targetZD))
             return;
-        if (this.playerEntity.vehicle != null && this.playerEntity.vehicle instanceof EntityBoat boat) {
-            boat.handleControlDirect(packetBoatControl.targetXD, packetBoatControl.targetZD, packetBoatControl.targetYRot);
-            packetBoatControl.entityId = boat.id;
-            this.mcServer.playerList.sendPacketToOtherPlayersAroundPoint(this.playerEntity, boat.x, boat.y, boat.z, 128, boat.world.dimension.id, packetBoatControl);
+        if (this.playerEntity.vehicle instanceof Entity vehicle) {
+            vehicle.handleControlDirect(packetVehicleControl.targetXD, packetVehicleControl.targetYD, packetVehicleControl.targetZD, packetVehicleControl.targetYRot);
+            if (vehicle instanceof MobPig pig && packetVehicleControl.fallDistance > 0f) {
+                pig.applyRiderFallDamage(packetVehicleControl.fallDistance);
+            }
+            if (vehicle.relaysVehicleControl()) {
+                packetVehicleControl.entityId = vehicle.id;
+                this.mcServer.playerList.sendPacketToOtherPlayersAroundPoint(this.playerEntity, vehicle.x, vehicle.y, vehicle.z, 128, vehicle.world.dimension.id, packetVehicleControl);
+            }
         }
     }
 
@@ -661,34 +668,38 @@ public class PacketHandlerServer extends PacketHandler
 
     @Override
     public void handleContainerClick(@NotNull PacketContainerClick packetContainerClick) {
-        if (this.playerEntity.containerMenu.containerId == packetContainerClick.window_Id && this.playerEntity.containerMenu.isSynched(this.playerEntity)) {
-            ItemStack itemstack = this.playerEntity.containerMenu.clicked(packetContainerClick.action, packetContainerClick.args, this.playerEntity);
-            if (ItemStack.areItemStacksEqual(packetContainerClick.itemStack, itemstack)) {
-                this.playerEntity.playerNetServerHandler.sendPacket(new PacketContainerAck(packetContainerClick.window_Id, packetContainerClick.actionId, true));
-                this.playerEntity.isChangingQuantityOnly = true;
-                this.playerEntity.containerMenu.broadcastChanges();
-                this.playerEntity.updateHeldItem();
-                this.playerEntity.isChangingQuantityOnly = false;
-            } else {
-                this.guiIdMap.put(this.playerEntity.containerMenu.containerId, packetContainerClick.actionId);
-                this.playerEntity.playerNetServerHandler.sendPacket(new PacketContainerAck(packetContainerClick.window_Id, packetContainerClick.actionId, false));
-                this.playerEntity.containerMenu.setSynched(this.playerEntity, false);
-                ArrayList<ItemStack> arraylist = new ArrayList<>();
-                for (int i = 0; i < this.playerEntity.containerMenu.slots.size(); i++) {
-                    arraylist.add(this.playerEntity.containerMenu.slots.get(i).getItemStack());
-                }
+        MenuAbstract menu = this.playerEntity.containerMenu;
+        if (menu.containerId != packetContainerClick.window_Id) {
+            return;
+        }
+
+        boolean stale = packetContainerClick.stateId != menu.getStateId();
 
-                this.playerEntity.updateCraftingInventory(this.playerEntity.containerMenu, arraylist);
+        menu.setRemoteUpdatesSuppressed(true);
+        menu.clicked(packetContainerClick.action, packetContainerClick.args, this.playerEntity);
+        menu.setRemoteUpdatesSuppressed(false);
+
+        if (packetContainerClick.changedSlots != null) {
+            for (Int2ObjectMap.Entry<ItemStack> entry : packetContainerClick.changedSlots.int2ObjectEntrySet()) {
+                int slot = entry.getIntKey();
+                if (slot >= 0 && slot < menu.slots.size()) {
+                    menu.setRemoteSlot(slot, entry.getValue());
+                }
             }
         }
+        this.playerEntity.setRemoteCarried(packetContainerClick.carriedItem);
+
+        if (stale) {
+            this.playerEntity.broadcastFullState(menu);
+        } else {
+            menu.broadcastChanges();
+            this.playerEntity.broadcastCarried(menu);
+        }
     }
 
     @Override
     public void handleContainerAck(@NotNull PacketContainerAck packet) {
-        short short1 = this.guiIdMap.get(this.playerEntity.containerMenu.containerId);
-        if (packet.shortWindowId == short1 && this.playerEntity.containerMenu.containerId == packet.windowId && !this.playerEntity.containerMenu.isSynched(this.playerEntity)) {
-            this.playerEntity.containerMenu.setSynched(this.playerEntity, true);
-        }
+        //reconciliation of state ids and delta corrections render container ack deprecated
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
index 5db1056dd..ebdc7e658 100644
--- a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -1,6 +1,7 @@
 package net.minecraft.server.player;
 
 import java.util.ArrayList;
+import java.util.Comparator;
 import java.util.List;
 
 import com.mojang.logging.LogUtils;
@@ -160,13 +161,14 @@ public class PlayerManager
         {
             return;
         }
+        List<ChunkCoordinate> chunksToAdd = new ArrayList<>();
         for(int _cx = chunkX - viewRadius; _cx <= chunkX + viewRadius; _cx++)
         {
             for(int _cz = chunkZ - viewRadius; _cz <= chunkZ + viewRadius; _cz++)
             {
                 if(!chunkWithinViewRadius(_cx, _cz, playerChunkX, playerChunkZ)) // If chunk was not in previous render radius add the chunk to the player
                 {
-                    getPlayerInstance(_cx, _cz, true).addPlayer(player);
+                    chunksToAdd.add(new ChunkCoordinate(_cx, _cz));
                 }
                 if(chunkWithinViewRadius(_cx - cDX, _cz - cDZ, chunkX, chunkZ))
                 {
@@ -181,6 +183,16 @@ public class PlayerManager
 
         }
 
+        chunksToAdd.sort(Comparator.comparingInt(c -> {
+            int ddx = c.x - chunkX;
+            int ddz = c.z - chunkZ;
+            return ddx * ddx + ddz * ddz;
+        }));
+        for(ChunkCoordinate chunk : chunksToAdd)
+        {
+            getPlayerInstance(chunk.x, chunk.z, true).addPlayer(player);
+        }
+
         player.viewingX = player.x;
         player.viewingZ = player.z;
     }
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 04cc95bc3..216a26b2b 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -278,10 +278,6 @@ public class WorldServer extends World {
     public void tick() {
         super.tick();
 
-        if (!this.players.isEmpty()) {
-            this.particleEmitters.tickServer(this, this.players, this.mcServer.particleRenderDistance);
-        }
-
         if (System.currentTimeMillis() - lastWeatherSend > 1000) {
             mcServer.playerList.sendPacketToAllPlayers(new PacketWeatherStatus(dimension.id, getCurrentWeather() != null ? getCurrentWeather().getId() : -1, getWeatherManager().getNextWeather() != null ? getWeatherManager().getNextWeather().getId() : -1, getWeatherManager().getWeatherDuration(), getWeatherManager().getWeatherIntensity(), getWeatherManager().getWeatherPower()));
             lastWeatherSend = System.currentTimeMillis();
diff --git a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index 5652e2676..92fef2466 100644
--- a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -27,6 +27,8 @@ public class ChunkProviderServer
     private final Map<ChunkPos, Chunk> chunkMap;
     private final List<Chunk> chunkList;
     private final WorldServer world;
+    private boolean decorating = false;
+    private boolean warnedRecursiveGeneration = false;
 
     public ChunkProviderServer(WorldServer world, ChunkLoader chunkLoader, ChunkGenerator chunkGenerator) {
         this.droppedChunksSet = new HashSet<>();
@@ -159,6 +161,13 @@ public class ChunkProviderServer
     public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         Chunk chunk = this.chunkMap.get(chunkPos);
         if (chunk == null) {
+            if (this.decorating) {
+                if (!this.warnedRecursiveGeneration) {
+                    this.warnedRecursiveGeneration = true;
+                    LOGGER.warn("Blocked recursive chunk generation at X:{}, Z:{} during decoration!", chunkPos.x(), chunkPos.z(), new Throwable("Stack trace"));
+                }
+                return this.emptyChunk;
+            }
             if (this.world.findingSpawnPoint || this.chunkLoadOverride) {
                 return prepareChunk(chunkPos, true);
             } else {
@@ -203,7 +212,13 @@ public class ChunkProviderServer
         if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
             if (this.chunkGenerator != null) {
-                this.chunkGenerator.decorate(chunk);
+                this.decorating = true;
+                this.warnedRecursiveGeneration = false;
+                try {
+                    this.chunkGenerator.decorate(chunk);
+                } finally {
+                    this.decorating = false;
+                }
                 chunk.setChunkModified();
             }
         }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
index 095655ba5..81de6c796 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
@@ -51,7 +51,7 @@ public class TrommelGenerator {
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
             .setInput(Blocks.DIRT_SCORCHED_RICH)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 15)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 4), 25)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1, 4), 25)
@@ -80,24 +80,24 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 6), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 2)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 2), 15)
-            .create("soul_sand");
+            .create("soulsand");
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
             .setInput(Blocks.BRIMSAND)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 2, 3), 35)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1, 2), 25)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 1, 2), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
             .create("brimsand");
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
             .setInput(Blocks.SULFUR)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 2, 5), 30)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 3), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 2, 5), 30)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 2, 4), 20)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 4)
